#include <stdio.h>
#include <stdlib.h>
#include "arenaGUI.h"

void displayArena(ARENA_H_TILE* arena, SDL_Window* window, TILE *tiles, int size_h, int size_w, int tile_size) {
	SDL_Rect tmp_tile_coord;
	int i,j;
	for (i=0; i<size_h; i++) {
		for (j=0; j<size_w; j++) {
			tmp_tile_coord.x = i * tile_size;
			tmp_tile_coord.y = j * tile_size;

			SDL_BlitSurface(getTileSurfaceFromID(tiles,getTileTypeID(arena,i,j)), NULL, SDL_GetWindowSurface(window), &tmp_tile_coord);

			SDL_UpdateWindowSurface(window);
		}
	}
}

int updateArena(SDL_Window* window, ARENA_H_TILE* arena, TILE *tiles, PLAYER *p_list) {
	//Ajouté
	SDL_Rect position;
	SDL_Rect oldposition;
	SDL_Rect IAposition;
	SDL_Rect oldIAposition;

	PLAYER *p1=NULL,*p2=NULL;

	p1=p_list;p2=p_list->suiv;

	printf("Nom player 1 : %s\n",p1->Name);
	printf("Nom player 2 : %s\n",p2->Name);

	printf("Nombre de joueur en vie : %i\n",NumberPlayerAlive(p_list));

	int action=0,actionIA=0;

	//Affichage des joueurs au début de la partie
	position.x = p1->PositionX * TILE_SIZE;
	position.y = p1->PositionY * TILE_SIZE;
	SDL_BlitSurface(p1->texture[DOWN], NULL, SDL_GetWindowSurface(window), &position);

	IAposition.x = p2->PositionX * TILE_SIZE;
	IAposition.y = p2->PositionY * TILE_SIZE;
	SDL_BlitSurface(p2->texture[DOWN], NULL, SDL_GetWindowSurface(window), &IAposition);

	SDL_UpdateWindowSurface(window);

	do {
		oldposition.x = p1->PositionX * TILE_SIZE;
		oldposition.y = p1->PositionY * TILE_SIZE;
		oldIAposition.x = p2->PositionX * TILE_SIZE;
		oldIAposition.y = p2->PositionY * TILE_SIZE;

		while(action == 0) {
			action=getKeyEvent();
		}

		if(action == -1){
			return 0;
		} else if(action == 1) {
			ActionPlayer(arena,tiles,p_list,p1,1); //Déplacement vers le haut
		} else if(action == 2) {
			ActionPlayer(arena,tiles,p_list,p1,2); //Déplacement vers la droite
		} else if(action == 3) {
			ActionPlayer(arena,tiles,p_list,p1,3); //Déplacement vers le bas
		} else if(action == 4) {
			ActionPlayer(arena,tiles,p_list,p1,4); //Déplacement vers la gauche
		} else if(action == 5) {
			//Regarder le perso en face, le plus près
			if (canAttackPlayer(p1,p2)==1) {
				AttackPlayer(p1,p2); //Voir quel player on choisit d'attaquer
			}
		}

		// On place le joueur à la bonne position
		position.x = p1->PositionX * TILE_SIZE;
		position.y = p1->PositionY * TILE_SIZE;

		if (position.x!=oldposition.x || position.y!=oldposition.y) {
			SDL_BlitSurface(getTileSurfaceFromID(tiles,getTileTypeID(arena,(oldposition.x)/TILE_SIZE,(oldposition.y)/TILE_SIZE)), NULL, SDL_GetWindowSurface(window), &oldposition);
			//SDL_BlitSurface(p1->texture[DOWN], NULL, SDL_GetWindowSurface(window), &position);
			SDL_BlitSurface(p1->texture[getRelativeDirection(oldposition, position)], NULL, SDL_GetWindowSurface(window), &position);
		}



		//Tour de l'IA
		actionIA = IAEngine(arena,tiles,p1,p2);
		printf("Tour de l'IA\n");
		if(actionIA == 5)
		{
			AttackPlayer(p1,p2);
		}
		else if ((actionIA >= 1) && (actionIA <= 4))
		{
			ActionPlayer(arena,tiles,p_list,p2,actionIA);
		}

		IAposition.x = p2->PositionX * TILE_SIZE;
		IAposition.y = p2->PositionY * TILE_SIZE;

		if (IAposition.x!=oldIAposition.x || IAposition.y!=oldIAposition.y) {
			SDL_BlitSurface(getTileSurfaceFromID(tiles,getTileTypeID(arena,(oldIAposition.x)/TILE_SIZE,(oldIAposition.y)/TILE_SIZE)), NULL, SDL_GetWindowSurface(window), &oldIAposition);
			//SDL_BlitSurface(p2->texture[DOWN], NULL, SDL_GetWindowSurface(window), &IAposition);
			SDL_BlitSurface(p2->texture[getRelativeDirection(oldIAposition, IAposition)], NULL, SDL_GetWindowSurface(window), &IAposition);
		}

		SDL_UpdateWindowSurface(window);

		action=0;actionIA=0;

	} while((p1->HealthPoints > 0) && (NumberPlayerAlive(p_list) > 1));

	printf("La partie est terminée\n");

	if(p1->HealthPoints > 0){
		printf("Vous avez gagné\n");
	} else {
		printf("Vous avez perdu\n");
	}

	//Si une des IA meurt, voir comment on le gère
	return 0;
}

int getKeyEvent()
{
	SDL_Event event;
	SDL_WaitEvent(&event); /* Récupération de l'événement dans event */

	switch(event.type) { /* Test du type d'événement */
	  	/* Si c'est un événement de type "Quitter" */
	    case SDL_QUIT :
	    	printf("QUITTER\n");
	    	return -1;
	    case SDL_KEYUP:
			switch(event.key.keysym.sym) { //La valeur de touche
				case SDLK_ESCAPE:
					printf("ESCAPE KEY\n");
					return -1;
				case SDLK_UP:
					printf("FLECHE DU HAUT\n");
					return 1;
				case SDLK_DOWN:
					printf("FLECHE DU BAS\n");
					return 3;
				case SDLK_RIGHT:
					printf("FLECHE DE DROITE\n");
					return 2;
				case SDLK_LEFT:
					printf("FLECHE DE GAUCHE\n");
					return 4;
				case SDLK_SPACE:
					printf("BARRE D'ESPACE\n");
					return 5;
			}
	}

	return 0;
}

/*
void updatePlayerPos(ARENA_H_TILE* arena, SDL_Window* window, PLAYER *player, TILE *tiles, SDL_Rect new_coord) {
	SDL_Rect old_coord;

	old_coord.x = player->PositionX;
	old_coord.y = player->PositionY;

	SDL_BlitSurface(getTileSurfaceFromID(tiles,getTileTypeID(arena,player->PositionX,player->PositionY)), NULL, SDL_GetWindowSurface(window), &old_coord);
	SDL_BlitSurface(player->texture[getRelativeDirection(old_coord, new_coord)], NULL, SDL_GetWindowSurface(window), &new_coord);

	SDL_UpdateWindowSurface(window);
}
*/
